<?php

namespace EWR\Carta\ControllerPlugin;

use XF\Mvc\Entity\AbstractCollection;

class PagePreview extends \XF\ControllerPlugin\AbstractPlugin
{
	public function actionPreview($wiki)
	{
		$html = \XF::app()->bbCode()->render($wiki->page_content, 'html', 'ewr_carta_page', $wiki,
			$wiki->getBbCodeRenderOptions($wiki, 'ewr_carta_page'));
		
		if ($wiki->page_type == 'html')
		{
			$html = htmlspecialchars_decode($html);
		}
		
		$parserRepo = \XF::repository('EWR\Carta:Parser');
		$html = $parserRepo->parseContentsFromHTML($wiki, $html);
		$html = $parserRepo->parseTemplatesFromHTML($wiki, $html);
		$html = $parserRepo->parseLinksFromHTML($wiki, $html);

		$viewParams = [
			'html' => $html,
		];
		return $this->view('EWR\Carta:PagePreview\Preview', 'EWRcarta_page_preview', $viewParams);
	}
}