<?php

namespace EWR\Carta\Pub\View;

class Page extends \XF\Mvc\View
{
	public function renderJson()
	{
		$wiki = $this->params['wiki'];
		
		$codePattern = '#\[template=([\w-]+)\](.*?)\[/template\]#si';
		$dataPattern = '#([\w-\s]+)=(.+)#si';
		
		$topNode = [];
		
		if (preg_match_all($codePattern, $wiki->page_content, $matches))
		{
			foreach ($matches[0] AS $key => $match)
			{
				$name = strtolower(trim($matches[1][$key]));
				$vars = explode("|", trim($matches[2][$key]));
				$subs = [];
				
				$subNode = ['type' => $name];
				
				foreach ($vars AS $var)
				{
					if (!empty($var))
					{
						$subs = array_map('trim', explode("=", $var, 2));
						
						if (!empty($subs[1]))
						{
							$subNode[$subs[0]] = $subs[1];
						}
					}
				}
				
				$topNode[] = $subNode;
			}
		}
		
		return $topNode;
	}
	
	public function renderXml()
	{
		$wiki = $this->params['wiki'];
		
		$codePattern = '#\[template=([\w-]+)\](.*?)\[/template\]#si';
		$dataPattern = '#([\w-\s]+)=(.+)#si';
		
		$document = new \DOMDocument('1.0', 'utf-8');
		$document->formatOutput = true;
		
		$topNode = $document->createElement($wiki->page_slug);
		
		if (preg_match_all($codePattern, $wiki->page_content, $matches))
		{
			foreach ($matches[0] AS $key => $match)
			{
				$name = strtolower(trim($matches[1][$key]));
				$vars = explode("|", trim($matches[2][$key]));
				$subs = [];
				
				$subNode = $document->createElement($name);
				
				foreach ($vars AS $var)
				{
					if (!empty($var))
					{
						$subs = array_map('trim', explode("=", $var, 2));
						
						if (!empty($subs[1]))
						{
							$varNode = $document->createElement($subs[0]);
							$varNode->appendChild(\XF\Util\Xml::createDomCdataSection($document, $subs[1]));
							$subNode->appendChild($varNode);
						}
					}
				}
				
				$topNode->appendChild($subNode);
			}
		}
		
		$document->appendChild($topNode);

		return $document->saveXML();
	}
}